#include <amxmodx>
#include <amxmisc>
#include <fun>
#include <cstrike>
#include <fakemeta>
#include <engine>
#include <hamsandwich>
#include <nvault> 
#include <ColorChat>


#define PLUGIN "Call of Duty: MW Mod"
#define VERSION "0.7.9 Beta"
#define AUTHOR "QTM_Peyote"

#define STANDARDOWA_SZYBKOSC 250.0

#define ZADANIE_POKAZ_INFORMACJE 672
#define ZADANIE_WSKRZES 704
#define ZADANIE_WYSZKOLENIE_SANITARNE 736
#define ZADANIE_POKAZ_REKLAME 768
#define ZADANIE_USTAW_SZYBKOSC 832

//#define BOTY 1

new SyncHudObj;
new SyncHudObj2;
new SyncHudObj3;
new g_msg_screenfade;

new sprite_white;
new sprite_blast;

new g_vault;

new podkladajacy;
new rozbrajajacy;

new doswiadczenia_za_zabojstwo;
new doswiadczenie_za_bombe;
new doswiadczenie_za_kase;
new doswiadczenie_za_kasez;
new doswiadczenie_za_totek;
new doswiadczenie_za_fail;

new Ubrania_CT[4][]={"sas","gsg9","urban","gign"};
new Ubrania_Terro[4][]={"arctic","leet","guerilla","terror"};

new const maxAmmo[31]={0,52,0,90,1,32,1,100,90,1,120,100,100,90,90,90,100,120,30,120,200,32,90,120,90,2,35,90,90,0,100};
new const maxClip[31] = { -1, 13, -1, 10,  1,  7,  1,  30, 30,  1,  30,  20,  25, 30, 35, 25,  12,  20, 
10,  30, 100,  8, 30,  30, 20,  2,  7, 30, 30, -1,  50 };

new informacje_przedmiotu_gracza[33][2];
new const nazwy_przedmiotow[][] = {"Brak", 
	"Buty Szturmowego", //1
	"Podwojna Kamizelka", //2
	"Wzmocniona Kamizelka", //3
	"Weteran Noza", //4
	"Zaskoczenie Wroga", //5
	"Plaszcz Partyzanta", //6 
	"Morfina", //7
	"Noz Komandosa", //8
	"Podrecznik Szpiega", //9
	"Tajemnica Generala", //10
	"Notatki Ninji", //11
	"Tajemnica Wojskowa", //12
	"AWP Sniper",//13
	"Adrenalina",//14
	"Tajemnica Rambo",//15
	"Wyszkolenie Sanitarne",//16
	"Kamizelka NASA",//17
	"Wytrenowany Weteran",//18
	"Apteczka",//19
	"Eliminator Rozrzutu",//20
	"Tytanowe Naboje",//21
	"Naboje Pulkownika",//22
	"Ogranicznik Rozrzutu",//23
	"Tarcza SWAT",//24
	"Wytrenowany Rekrut",//25
	"Pancerz Nomexowy",//26
	"Notatki Kapitana",//27
	"Modul odrzutowy",//28
	"Platynowe naboje",//29
	"Tajemnica Pirotechnika",//30
	"Tajemnica medyka",//31
	"Tajemnica Deaglarza",//32
	"Amfetamina"//33
}

new const opisy_przedmiotow[][] = {"Zabij kogos aby dostac przedmiot", 
	"Cicho biegasz", 
	"Obniza uszkodzenia zadawane graczowi o LW",
	"Obniza uszkodzenia zadawane graczowi o LW", 
	"Zadajesz wieksze obrazenia nozem",
	"Gdy trafisz kogos od tylu, obrazenia sa 2 razy wieksze", 
	"Masz LW premii niewidocznosci",
	"1/LW szans do ponownego odrodzenia sie po smierci",
	"Natychmiastowe zabicie z Noza",
	"Masz 1/LW szans na natychmiastowe zabicie z HE. Posiadasz takze ubranie wroga",
	"Natychmiastowe zabicie granatem HE. Zadajesz LW dodatkowych obrazen",
	"Mozesz zrobic podwojny skok w powietrzu",
	"Twoje obrazenia sa zredukowane o 5. Masz 1/LW szans na oslepienie wroga",
	"Natychmiastowe zabicie z AWP",
	"Za kazdego Fraga dostajesz 50 zycia",
	"Za kazdego Fraga dostajesz pelen magazynek oraz +20 hp",
	"Dostajesz 10 HP co 5 sekund",
	"Masz 500 pancerza",
	"Dostajesz +100 HP co runde, wolniej biegasz",
	"Uzyj, aby uleczyc sie do maksymalnej ilosci HP",
	"Nie posiadasz rozrzutu broni",
	"Zadajesz 10 obrazen wiecej",
	"Zadajesz 20 obrazen wiecej",
	"Twoj rozrzut jest mniejszy",
	"Nie dzialaja na ciebie zadne przedmioty",
	"Dostajesz +50 HP co runde, wolniej biegasz",
	"Masz 1/LW szans na odbicie pocisku przez pancerz",
	"Jestes odporny na 3 pociski w kazdej rundzie",
	"Nacisnij CTRL i SPACE aby uzyc modulu, modul laduje sie co 4 sekundy",
	"Zadajesz 30 obrazen wiecej",
	"Dostajesz 5 rakiet",
	"Dostajesz dodatkowe 200 HP",
	"Natychmiaste Zabicie z Deagle",
	"Zadajesz 50 obrazen wiecej"
};

new nazwa_gracza[33][64];
new klasa_gracza[33];
new poziom_gracza[33] = 1;
new doswiadczenie_gracza[33];

new nowa_klasa_gracza[33];

new const doswiadczenie_poziomu[] = {
0,120,160,400,560,760,1120,1540,2500,2860,
3260,4360,5560,6080,6640,8440,9080,10780,11860,12620,
13020,13440,14320,14780,17180,20180,20700,22320,22880,24620,
25220,25840,27760,31720,35800,37900,41500,42980,43740,45300,
47700,49340,51860,57020,61420,66820,68660,69600,73440,74420,
80420,86540,91740,94920,96000,99300,102660,107220,114180,117720,
118920,126240,131200,133720,138840,140140,141460,146820,149540,156440,
160640,169160,173480,180780,188180,191180,194220,203460,212820,219140,
222340,227200,230480,238780,240460,248960,252400,254140,264700,275380,
278980,289900,291740,295460,297340,306840,316440,320320,326200,336100,
342100,348160,354280,360460,370860,381360,391960,396240,409200,411380,
420180,422400,435840,447140,456260,460860,463180,467860,477300,486820,
501220,513320,523080,528000,540400,550400,565520,575680,578240,583400,
591200,596440,607000,614980,623020,636520,639240,641980,644740,647520,
650320,653140,658820,667400,676040,687640,693480,705240,708200,711180,
720180,735280,747440,750500,765900,775200,778320,794020,809820,828900,
835300,841740,857940,874240,884080,890680,907280,920640,927360,937500,
954500,968180,975060,988900,992380,1002880,1024000,1045240,1066600,1070180,
1080980,1088220,1102780,1113760,1128480,1132180,1143340,1162040,1165800,1188480,
1199880,1222800,1230480,1249780,1269180,1284780,1292620,1296560,1316360,1324320,
1348320,1364400,1380560,1400860,1417180,1433580,1441820,1445960,1458440,1483520,
1491920,1517240,1529960,1555520,1559800,1564100,1577060,1603100,1607460,1611840,
1616240,1638340,1664980,1673900,1691820,1696320,1709880,1723500,1750860,1769180,
1782980,1796840,1820040,1834020,1852740,1862140,1890460,1909420,1933220,1961900,
1971500,1990780,2000460,2019900,2029660,2039460,2068980,2088740,2108580,2123520,
2148520,2153540,2168660,2193960,2199040,2219440,2239920,2245060,2270860,2296760,
2322760,2348860,2359340,2375120,2390960,2417460,2444060,2454740,2460100,2476240,
2503240,2508660,2519540,2535920,2563320,2596320,2607360,2612900,2624020,2646340,
2657540,2685640,2719480,2730800,2759200,2776300,2804900,2827860,2850900,2874020,
2897220,2908860,2920540,2932260,2944020,2973520,3003120,3020940,3026900,3044840,
3050840,3080940,3105100,3111160,3141560,3159860,3172100,3202800,3233600,3239780,
3276980,3308080,3320560,3351860,3370700,3383300,3414900,3421240,3459400,3478540,
3516940,3542620,3568380,3574840,3587800,3600800,3639920,3672620,3692300,3731780,
3744980,3778080,3811280,3831260,3837940,3844640,3864800,3898500,3905260,3939160,
3979960,4014060,4055100,4096260,4130660,4172060,4199740,4241380,4255300,4276240,
4290240,4304280,4346520,4388880,4403040,4410140,4452860,4467140,4488620,4531700,
4553300,4574960,4603920,4611180,4618460,4662260,4691540,4720900,4765060,4794580,
4816780,4853880,4868760,4898600,4913560,4943560,4973640,5011340,5041580,5079480,
5109880,5140360,5186200,5193860,5201540,5232340,5240060,5263280,5309840,5333180,
5379980,5419080,5466120,5497560,5529080,5560680,5608200,5632020,5639980,5687860,
5735860,5751900,5792100,5832400,5872800,5905200,5913320,5954020,6002980,6043880,
6084880,6109540,6150740,6183780,6216900,6225200,6258480,6291840,6333640,6350400,
6392400,6426080,6468280,6519040,6527520,6544520,6578600,6612760,6629880,6647040,
6698640,6715880,6767720,6811020,6837060,6889260,6941580,6994020,7011540,7064220,
7090620,7134720,7143560,7170140,7179020,7214620,7232460,7250340,7295140,7331060,
7367060,7394120,7412200,7439380,7457540,7484840,7512200,7521340,7539660,7576380,
7631580,7659240,7705440,7714700,7742540,7770440,7798400,7845100,7901260,7938780,
7995180,8042280,8061160,8117920,8174800,8222300,8260380,8269920,8308160,8346480,
8365680,8413780,8452340,8500640,8539360,8597560,8626720,8636460,8695020,8704800,
8753800,8812720,8871760,8901340,8921100,8960700,8980540,9000420,9040260,9070200,
9080200,9140320,9190520,9200580,9230820,9240920,9261160,9301720,9352520,9393240,
9444240,9485120,9546560,9608120,9659520,9711020,9741980,9804020,9866180,9876560,
9938960,9991060,10043260,10053720,10064200,10085200,10106240,10127320,10180120,10222440,
10275440,10286060,10339260,10392560,10413920,10456720,10521040,10564000,10607040,10671720,
10693320,10747420,10779940,10834240,10877760,10899560,10921400,10987040,10998000,11019960,
11052960,11075000,11119160,11141280,11185600,11218900,11230020,11263440,11274600,11308140,
11364140,11386580,11431540,11454060,11465340,11499240,11567160,11623860,11657940,11680700,
11737700,11760540,11806300,11863600,11909520,11955520,11978560,12001640,12013200,12071100,
12117500,12129120,12198960,12245600,12257280,12280680,12339280,12351020,12386300,12398080,
12445280,12457100,12516300,12528160,12540040,12611440,12659120,12718820,12742740,12802640,
12826640,12862700,12886780,12922960,12971280,13007580,13080300,13153140,13189620,13201800,
13238400,13311720,13323960,13385260,13458940,13471240,13532840,13569860,13619300,13693580,
13730780,13755620,13780500,13792960,13817920,13867920,13930520,13980680,14005800,14030960,
14093960,14169680,14194960,14258260,14270940,14334440,14410760,14474460,14538260,14551040,
14589440,14640720,14666400,14730700,14756460,14795160,14821000,14872760,14937560,14989480,
15054480,15067500,15106620,15145800,15211200,15250500,15263620,15303040,15382000,15408360,
15461160,15527260,15593460,15606720,15646560,15699760,15739720,15766400,15793120,15873400,
15913600,15980700,16034460,16115220,16155660,16223160,16277240,16358480,16426280,16439860,
16467060,16535160,16576080,16658040,16671720,16740220,16808820,16863780,16918820,16946380,
17029180,17084460,17139820,17181400,17209160,17292560,17348240,17417940,17473780,17501740,
17515740,17585840,17613920,17670160,17698320,17754720,17797080,17853640,17924440,17952800,
17967000,18038100,18095060,18152100,18166380,18252180,18295140,18338160,18409960,18467480,
18525080,18611600,18698240,18756080,18770560,18814060,18828580,18857660,18945020,19003340,
19090940,19149420,19193340,19222660,19296060,19325460,19413780,19502220,19516980,19590880,
19679680,19768600,19783440,19813160,19902440,19991840,20021680,20081440,20096400,20171300,
20231300,20261340,20306460,20396820,20442060,20502460,20578060,20668900,20714380,20775100,
20805500,20881600,20896840,20957880,21003720,21064920,21095560,21187600,21264400,21325920,
21372120,21433800,21449240,21480160,21526600,21588600,21650680,21697300,21759540,21853020,
21915420,22009140,22087340,22149980,22244060,22338260,22385420,22464120,22511400,22606080,
22621880,22716800,22796000,22875300,22970580,23018280,23050120,23097940,23113900,23177820,
23209820,23289920,23354080,23450440,23482600,23547000,23643720,23724420,23789060,23805240,
23821440,23902540,23918780,23951300,24032700,24049000,24114280,24212320,24294120,24343260,
24441660,24507340,24540220,24606060,24622540,24655540,24672060,24721680,24754800,24771380,
24837780,24904260,24954180,24970840,25054240,25154440,25221320,25254800,25271560,25372240,
25405840,25456300,25523660,25540520,25557400,25641900,25709580,25794280,25811240,25828220,
25862220,25964340,26049540,26151900,26254380,26322780,26374140,26442700,26459860,26494220,
26528620,26563060,26597540,26683840,26701120,26787620,26874220,26926240,26943600,27030500,
27047900,27135000,27222200,27309500,27326980,27414480,27449520,27467060,27519740,27572480,
27678080,27748560,27819120,27889760,27907440,27925140,28031460,28084680,28173480,28244600,
28351400,28404860,28476220,28494080,28529840,28583540,28619380,28673200,28780960,28870860,
28960860,29014920,29069040,29105160,29177480,29213680,29286160,29376860,29431340,29449520,
29504120,29522340,29613540,29704840,29796240,29851140,29906100,29961120,30016200,30126480,
30144880,30218560,30237000,30347760,30403200,30477200,30532760,30588380,30644060,30681220,
30699820,30774300,30848860,30923500,31035580,31091680,31166560,31204040,31316600,31429280,
31523280,31560920,31655120,31673980,31692860,31749560,31787400,31806340,31920100,32015000,
32072000,32167100,32186140,32224260,32262420,32281520,32300640,32377200,32453840,32568920,
32684120,32799440,32857160,32876420,32953540,33011440,33050080,33108100,33146820,33166200,
33185600,33205020,33321660,33399500,33438460,33555460,33653060,33672600,33731280,33790020,
33907620,33946860,34064700,34163000,34202360,34320560,34340280,34438980,34478500,34518060,
34597260,34716180,34736020,34815460,34934740,34994440,35014360,35094120,35134040,35233940,
35333940,35353960};

new punkty_gracza[33];
new zdrowie_gracza[33];
new inteligencja_gracza[33];
new wytrzymalosc_gracza[33];
new Float:redukcja_obrazen_gracza[33];
new kondycja_gracza[33];
new maksymalne_zdrowie_gracza[33];
new Float:szybkosc_gracza[33];

new bool:gracz_resetuje[33];

enum { NONE = 0, Snajper, Komandos, Strzelec, Obronca, Medyk, Wsparcie, Saper, Demolitions, Rusher, Rambo, Partyzant, Szpieg, Szturmowiec, StrzelecWsparcia, LekkiZolnierz, Rebeliant, Terrorysta, Pirotechnik,
Morderca, Nozownik, SWAT, Zwiadowca, Kamikadze,Principes, DrHouse, Nero, Nokia, Killer, Kapral,Deaglarz, Hitler, Metalowiec};
new const zdrowie_klasy[] = { 0, 120, 140, 110, 120, 110, 100, 100, 110, 100, 130, 100, 70, 140, 125, 100, 125, 70, 130, 110, 200, 150, 150,200, 100,150,140,150,180,500,150,130,155,190,150};
new const Float:szybkosc_klasy[] = {0.0, 1.2, 1.35, 0.8, 0.8, 1.0, 1.0, 1.0, 1.0, 1.3 , 1.15, 1.1, 1.2, 0.9, 0.9, 1.35, 1.2, 1.5, 1.2, 1.1, 1.6, 1.3, 1.2,2.3, 1.5,2.0,1.4,1.3,1.1,1.6,1.5,1.3,1.5,1.5,1.3};
new const pancerz_klasy[] = { 0, 100, 100, 100, 150, 100, 0, 100, 100, 0, 150, 0, 0, 150, 50, 0, 25, 0, 50, 200, 100, 120, 100,200,100,50,200,0,150,100,250,150,50,300,50};
new const nazwy_klas[][] = {"Brak",
	"Snajper",
	"Komandos",
	"Strzelec wyborowy",
	"Obronca",
	"Medyk",
	"Wsparcie ogniowe",
	"Saper",
	"Demolitions",
	"Rusher",
	"Rambo (Klasa Premium)",
	"Partyzant",
	"Szpieg",
	"Szturmowiec",
	"Strzelec Wsparcia",
	"Lekki Zolniez",
	"Rebeliant",
	"Terrorysta",
	"Pirotechnik",
	"Morderca",
	"Nozownik",
	"SWAT",
	"Zwiadowca",
	"Kamikadze",
	"Principes",
	"Dr.House (Klasa Premium)",
	"Nero",
	"Nokia",
	"Killer",
	"Morderca",
	"Kapral",
	"Deaglarz",
	"Hitler (Klasa Premium)",
	"Metalowiec"
};

new const opisy_klas[][] = {"Brak",
	"Dostaje AWP, scout i deagle, 120hp bazowe, 1/3 szansy natychmiastowego zabicia noza, 110% biegu, 100 pancerza",
	"Dostaje Deagle, 140hp bazowe, Natychmiastowe zabicie z noza (prawy przycisk myszy), 135% biegu, 100 pancerza",
	"Dostaje AK i M4A1, 110hp bazowe, 80 % biegu, 100 pancerza",
	"Dostaje M249 (Krowa), 120hp bazowe, 80% biegu, jest odporny na miny, ma wszystkie granaty, 150 pancerza",
	"Dostaje UMP45, 110hp bazowe, posiada apteczke, 100 pancerza",
	"Dostaje MP5, 100 hp bazowe, Ma trzy rakiety,ktore po trafieniu przeciwnika zadaja duo obrazen",
	"Dostaje P90, 100hp bazowe, 100 pancerza, Dostaje 4 miny, gdy ktos w nie wejdzie wybuchaja",
	"Dostaje AUG, 110 hp bazowe, 100 pancerza, Ma wszystkie granaty, Dostaje 2 dynamity, ktry zabiera sporo zycia wszystkim znajdujcym si blisko niego",
	"Dostaje szotgana M3, 100 hp bazowe, 130% biegu",
	"Dostaje m4a1,deagle, 130 hp bazowe, 120% biegu, za kazde zabojstwo +20 hp oraz pelen magazynek, podwojny skok",
	"Dostaje P90 + FLASH, 100 hp bazowe + mniej widzialny",
	"Dostaje deagla, 70 hp bazowe, ma ubranie wroga",
	"Dostaje M4 + deagle + he, 140 hp bazowe + 150 kamizelki, wolniej biega",
	"Dostaje G3/SG-1, 125 hp bazowe, ma 1 rakiete",
	"Dostaje galil + p228, 100 hp bazowe, szybciej biega",
	"Dostaje sg552 + 1 mine + 1 HE, 100 hp bazowe",
	"Dostaje elites ak47, 70 hp bazowe, o wiele szybciej biega",
	"Dostaje deagle, 130 hp bazowe, wszystkie granaty, miny i rakiety",
	"Dostaje M4 deagle, 110 hp bazowe, wszystkie granaty, 200 kamizelki",
	"Dostaje glock, 200 hp bazowe, HE Flash, 100 kamizelki szybko biega moze polegac na swojim nozu",
	"Dostaje M4, 120 hp bazowe, wszystkie granaty, 120 kamizelki",
	"Dostaje elites i tmp, 150 hp bazowe, wszystkie granaty, 100 kamizelki",
	"Dostaje deagle 200 hp bazowe,200 kamizelki ,najszybszy z klas...",
	"Dostaje awp,deagle,150 hp bazowe,50 kamizelki,4 dynamity,Bardzo Szybki..",
	"Dostaje awp,deagle,150 hp bazowe,50 kamizelki,4 dynamity,Bardzo Szybki..",
	"Dostaje awp,m4a1,ak47,deagle, 140 hp bazowe,140 % szybkosci ,200 kamilelki,3 rakiety..",
	"Dostaje m3,deagle,3 dynamity,130% biegu,150 hp bazowe..",
	"Dostaje mp5,p228,he,8 apteczek,180 hp bazowe ,110 % biegu.",
	"Dostaje tylko  n ,500 hp bazowe,170 % biegu...Klasa Dedykowana",
	"Dostaje ak47,usp, 150 hp bazowe ,150 % biegu ,250 kamizelki",
	"Ma Tylko Deagle,155 hp bazowe,50 kamizelki ,150 % biegu...",
	"Dostaje ak47 oraz p228,2 miny,190 hp bazowe ,150 % biegu ,300 kamizelki..",
	"Dostaje gail ,deagle ,1 rakiete ,150 hp bazowe,130 % biegu,50 kamizelki.."
         			  
};

new ilosc_apteczek_gracza[33];
new ilosc_rakiet_gracza[33];
new Float:poprzednia_rakieta_gracza[33];
new ilosc_min_gracza[33];
new ilosc_dynamitow_gracza[33];
new ilosc_skokow_gracza[33];

new bool:freezetime = true;

public plugin_init() 
{
	register_plugin(PLUGIN, VERSION, AUTHOR);
	
	g_vault = nvault_open("CodMod");
	
	register_think("Apteczka","ApteczkaThink");
	
	RegisterHam(Ham_TakeDamage, "player", "TakeDamage");
	RegisterHam(Ham_Spawn, "player", "Odrodzenie", 1);
	RegisterHam(Ham_Touch, "armoury_entity", "DotykBroni");
	RegisterHam(Ham_Touch, "weapon_shield", "DotykBroni");
	RegisterHam(Ham_Touch, "weaponbox", "DotykBroni");
	
	register_forward(FM_CmdStart, "CmdStart");
	register_forward(FM_EmitSound, "EmitSound");
	
	register_logevent("PoczatekRundy", 2, "1=Round_Start"); 
	register_logevent("BombaPodlozona", 3, "2=Planted_The_Bomb");
	
	register_event("SendAudio", "BombaRozbrojona", "a", "2&%!MRAD_BOMBDEF");
	register_event("BarTime", "RozbrajaBombe", "be", "1=10", "1=5");
	register_event("DeathMsg", "Death", "ade");
	register_event("Damage", "Damage", "b", "2!=0");
	register_event("CurWeapon","CurWeapon","be", "1=1");
	register_event("HLTV", "NowaRunda", "a", "1=0", "2=0");
	
	register_touch("Rocket", "*" , "DotykRakiety");
	register_touch("Mine", "player",  "DotykMiny");
	
	register_cvar("cod_killxp", "80");
	register_cvar("cod_bombxp", "200");
	
	register_clcmd("say /klasa", "WybierzKlase");
	register_clcmd("say /klasy", "OpisKlasy");
	register_clcmd("say /przedmiot", "OpisPrzedmiotu");
	register_clcmd("say /item", "OpisPrzedmiotu");
	register_clcmd("say /drop", "WyrzucPrzedmiot");
	register_clcmd("say /wyrzuc", "WyrzucPrzedmiot");
	register_clcmd("say /reset", "KomendaResetujPunkty");
	register_clcmd("say /sklep", "Sklep");
	register_clcmd("fullupdate", "BlokujKomende");
	
	register_clcmd("cl_autobuy", "BlokujKomende");
	register_clcmd("say /molotov", "BlokujKomende");
	register_clcmd("say molotov", "BlokujKomende");
	register_clcmd("cl_rebuy", "BlokujKomende");
	register_clcmd("cl_setautobuy","BlokujKomende");
	register_clcmd("rebuy", "BlokujKomende");
	register_clcmd("autobuy", "BlokujKomende");
	register_clcmd("glock", "BlokujKomende");
	register_clcmd("usp", "BlokujKomende");
	register_clcmd("p228", "BlokujKomende");
	register_clcmd("deagle", "BlokujKomende");
	register_clcmd("elites", "BlokujKomende");
	register_clcmd("fn57", "BlokujKomende");
	register_clcmd("m3", "BlokujKomende");
	register_clcmd("XM1014", "BlokujKomende");
	register_clcmd("mac10", "BlokujKomende");
	register_clcmd("tmp", "BlokujKomende");
	register_clcmd("mp5", "BlokujKomende");
	register_clcmd("ump45", "BlokujKomende");
	register_clcmd("p90", "BlokujKomende");
	register_clcmd("galil", "BlokujKomende");
	register_clcmd("ak47", "BlokujKomende");
	register_clcmd("scout", "BlokujKomende");
	register_clcmd("sg552", "BlokujKomende");
	register_clcmd("awp", "BlokujKomende");
	register_clcmd("g3sg1", "BlokujKomende");
	register_clcmd("famas", "BlokujKomende");
	register_clcmd("m4a1", "BlokujKomende");
	register_clcmd("bullpup", "BlokujKomende");
	register_clcmd("sg550", "BlokujKomende");
	register_clcmd("m249", "BlokujKomende");
	register_clcmd("shield", "BlokujKomende");
	register_clcmd("hegren", "BlokujKomende");
	register_clcmd("sgren", "BlokujKomende");
	register_clcmd("flash", "BlokujKomende");

	register_concmd("cod_setlvl", "cmd_setlvl", ADMIN_IMMUNITY, "<name> <level>");

	g_msg_screenfade = get_user_msgid("ScreenFade");
	SyncHudObj = CreateHudSyncObj();
	SyncHudObj2 = CreateHudSyncObj();
	SyncHudObj3 = CreateHudSyncObj();
	doswiadczenia_za_zabojstwo = get_cvar_num("cod_killxp");
	doswiadczenie_za_bombe = get_cvar_num("cod_bombxp");
	doswiadczenie_za_kase = 100;
	doswiadczenie_za_kasez = 300;
	doswiadczenie_za_totek = 200;
	doswiadczenie_za_fail = 1;
	
	set_task(30.0, "Pomoc");
}

public Sklep(id)
{
	new menu = menu_create("Sklepik:", "Sklep_Handle");
	menu_additem(menu, "Ketonal \r[Leczy 20 HP] \yKoszt: \r1500$");
	menu_additem(menu, "Flegamina \r[Leczy 50 HP] \yKoszt: \r3000$");
	menu_additem(menu, "Aspirina \r[Leczy 100 HP] \yKoszt: \r5000$");
	menu_additem(menu, "RedBull \r[Wysoki Skok + Szybkie Chodzenie] \yKoszt: \r2000$");
	menu_additem(menu, "Lotto \r[Totek] \yKoszt: \r2000$");
	menu_additem(menu, "Doswiadczenie \r[Dodaje 100 EXP] \yKoszt: \r5000$");
	menu_additem(menu, "Super Doswiadczenie \r[Dodaje 300 EXP] \yKoszt: \r10000$");
	menu_display(id, menu);
}

public Sklep_Handle(id, menu, item) 
{
	client_cmd(id, "spk QTM_CodMod/select");
	
	if(item == MENU_EXIT)
	{
		menu_destroy(menu);
		return PLUGIN_CONTINUE;
	}
	menu_display(id, menu);
	new kasa_gracza = cs_get_user_money(id);
	new hp = get_user_health(id);
	switch(item) 
	{ 
		case 0:
		{
			new koszt = 1500;
			if (kasa_gracza<koszt)
			{
				ColorChat(id,GREEN,"[SKLEP]^x01 Nie masz wystarczajacej ilosci pieniedzy.");
				return PLUGIN_CONTINUE;
			}
			if(hp >= maksymalne_zdrowie_gracza[id])
			{
				ColorChat(id,GREEN,"[SKLEP]^x01 Jestes w pelni uleczony.");
				return PLUGIN_CONTINUE;
			}
			cs_set_user_money(id, kasa_gracza-koszt);
			new ammount=20;
			new nowe_zdrowie = (hp+ammount<maksymalne_zdrowie_gracza[id])? hp+ammount: maksymalne_zdrowie_gracza[id];
			set_user_health(id, nowe_zdrowie);
			ColorChat(id,GREEN,"[SKLEP]^x01 Kupiles^x03 Ketonal");
		}
		case 1:
		{
			new koszt = 3000;
			if (kasa_gracza<koszt)
			{
				ColorChat(id,GREEN,"[SKLEP]^x01 Nie masz wystarczajacej ilosci pieniedzy.");
				return PLUGIN_CONTINUE;
			}
			if(hp >= maksymalne_zdrowie_gracza[id])
			{
				ColorChat(id,GREEN,"[SKLEP]^x01 Jestes w pelni uleczony.");
				return PLUGIN_CONTINUE;
			}
			cs_set_user_money(id, kasa_gracza-koszt);
			new ammount=50;
			new nowe_zdrowie = (hp+ammount<maksymalne_zdrowie_gracza[id])? hp+ammount: maksymalne_zdrowie_gracza[id];
			set_user_health(id, nowe_zdrowie);
			ColorChat(id,GREEN,"[SKLEP]^x01 Kupiles^x03 Flegamine");
		}
		case 2:
		{
			new koszt = 5000;
			if (kasa_gracza<koszt)
			{
				ColorChat(id,GREEN,"[SKLEP]^x01 Nie masz wystarczajacej ilosci pieniedzy.");
				return PLUGIN_CONTINUE;
			}
			if(hp >= maksymalne_zdrowie_gracza[id])
			{
				ColorChat(id,GREEN,"[SKLEP]^x01 Jestes w pelni uleczony.");
				return PLUGIN_CONTINUE;
			}
			cs_set_user_money(id, kasa_gracza-koszt);
			new ammount=100;
			new nowe_zdrowie = (hp+ammount<maksymalne_zdrowie_gracza[id])? hp+ammount: maksymalne_zdrowie_gracza[id];
			set_user_health(id, nowe_zdrowie);
			ColorChat(id,GREEN,"[SKLEP]^x01 Kupiles^x03 Aspirine");
		}
		case 3:
		{
			new koszt = 2000;
			if (kasa_gracza<koszt)
			{
				ColorChat(id,GREEN,"[SKLEP]^x01 Nie masz wystarczajacej ilosci pieniedzy.");
				return PLUGIN_CONTINUE;
			}
			cs_set_user_money(id, kasa_gracza-koszt);
			set_user_gravity(id,get_user_gravity(id) - 0.3);
			set_user_maxspeed(id,get_user_maxspeed(id) + 10.0);
			ColorChat(id,GREEN,"[SKLEP]^x01 Kupiles^x03 RedBulla");
		}
		case 4:
		{
			new kasa = cs_get_user_money(id)
			new koszt = 2000;
			if (kasa_gracza<koszt)
			{
				ColorChat(id,GREEN,"[SKLEP]^x01 Nie masz wystarczajacej ilosci pieniedzy.");
				return PLUGIN_CONTINUE;
			}
			cs_set_user_money(id, kasa_gracza-koszt);
			ColorChat(id,GREEN,"[SKLEP]^x01 Kupiles kupon Totolotka");
			ColorChat(id,GREEN,"[SKLEP]^x01 Trwa losowanie...");
			
			new rand = random_num(0,15);
			switch(rand) 
			{
				case 0:
				{
					ColorChat(id,GREEN,"[SKLEP]^x01 Wygrales^x03 10$^x01 !")
					cs_set_user_money(id, kasa + 10)
				}
				case 1:
				{
					ColorChat(id,GREEN,"[SKLEP]^x01 Wygrales^x03 Redbulla^x01 !")
					set_user_gravity(id,get_user_gravity(id) - 0.3);
					set_user_maxspeed(id,get_user_maxspeed(id) + 10.0);
				}
				case 2:
				{
					ColorChat(id,GREEN,"[SKLEP]^x01 Niestety nic nie wygrales !")
				}
				case 3:
				{
					ColorChat(id,GREEN,"[SKLEP]^x01 Wygrales^x03 300$^x01 !")
					cs_set_user_money(id, kasa + 300)
				}
				case 4:
				{
					ColorChat(id,GREEN,"[SKLEP]^x01 Wygrales^x03 1000$^x01 !")
					cs_set_user_money(id, kasa + 1000)
				}
				case 5:
				{
					ColorChat(id,GREEN,"[SKLEP]^x01 Niestety nic nie wygrales !")
				}
				case 6:
				{
					ColorChat(id,GREEN,"[SKLEP]^x01 Niestety nic nie wygrales !")
				}
				case 7:
				{
					ColorChat(id,GREEN,"[SKLEP]^x01 Przegrales^x03 Wszystko^x01 !")
					cs_set_user_money(id, kasa - kasa_gracza)
				}
				case 8:
				{
					ColorChat(id,GREEN,"[SKLEP]^x01 Niestety nic nie wygrales !")
				}
				case 9:
				{
					ColorChat(id,GREEN,"[SKLEP]^x01 Wygrales^x03 300 EXP^x01 !")
					doswiadczenie_gracza[id] += doswiadczenie_za_kase;
				}
				case 10:
				{
					ColorChat(id,GREEN,"[SKLEP]^x01 Wygrales 200 EXP^x01 !")
					doswiadczenie_gracza[id] += doswiadczenie_za_totek;
				}
				case 11:
				{
					ColorChat(id,GREEN,"[SKLEP]^x01 Niestety nic nie wygrales !")
				}
				case 12:
				{
					ColorChat(id,GREEN,"[SKLEP]^x01 Wygrales^x03 1 EXP^x01 !")
					doswiadczenie_gracza[id] += doswiadczenie_za_fail;
				}
			}
			SprawdzPoziom(id);
			return PLUGIN_CONTINUE;
		}
		case 5:
		{
			new koszt = 5000;
			if (kasa_gracza<koszt)
			{
				ColorChat(id,GREEN,"[SKLEP]^x01 Nie masz wystarczajacej ilosci pieniedzy.");
				return PLUGIN_CONTINUE;
			}
			cs_set_user_money(id, kasa_gracza-koszt);
			doswiadczenie_gracza[id] += doswiadczenie_za_kase;
			ColorChat(id,GREEN,"[SKLEP]^x01 Kupiles^x03 Doswiadczenie");
			SprawdzPoziom(id);
		}
		case 6:
		{
			new koszt = 10000;
			if (kasa_gracza<koszt)
			{
				ColorChat(id,GREEN,"[SKLEP]^x01 Nie masz wystarczajacej ilosci pieniedzy.");
				return PLUGIN_CONTINUE;
			}
			cs_set_user_money(id, kasa_gracza-koszt);
			doswiadczenie_gracza[id] += doswiadczenie_za_kasez;
			ColorChat(id,GREEN,"[SKLEP]^x01 Kupiles^x03 Super Doswiadczenie");
			SprawdzPoziom(id);
		}
	}
	return PLUGIN_CONTINUE;
}

public plugin_cfg() 
{	
	server_cmd("sv_maxspeed 1600");
}

public plugin_precache()
{
	sprite_white = precache_model("sprites/white.spr") ;
	sprite_blast = precache_model("sprites/dexplo.spr");
	
	precache_sound("QTM_CodMod/select.wav");
	precache_sound("QTM_CodMod/start.wav");
	precache_sound("QTM_CodMod/start2.wav");
	precache_sound("QTM_CodMod/levelup.wav");
	
	precache_model("models/w_medkit.mdl");
	precache_model("models/rpgrocket.mdl");
	precache_model("models/mine.mdl");
}

public CmdStart(id, uc_handle)
{
	if(!is_user_alive(id))
		return FMRES_IGNORED;
		
	new button = get_uc(uc_handle, UC_Buttons);
	new oldbutton = get_user_oldbutton(id);
	new flags = get_entity_flags(id);
	
	if(informacje_przedmiotu_gracza[id][0] == 11 || klasa_gracza[id] == Rambo)
	{
		if((button & IN_JUMP) && !(flags & FL_ONGROUND) && !(oldbutton & IN_JUMP) && ilosc_skokow_gracza[id] > 0)
		{
			ilosc_skokow_gracza[id]--;
			new Float:velocity[3];
			entity_get_vector(id,EV_VEC_velocity,velocity);
			velocity[2] = random_float(265.0,285.0);
			entity_set_vector(id,EV_VEC_velocity,velocity);
		}
		else if(flags & FL_ONGROUND)
		{	
			ilosc_skokow_gracza[id] = 0;
			if(informacje_przedmiotu_gracza[id][0] == 11)
				ilosc_skokow_gracza[id]++;
			if(klasa_gracza[id] == Rambo)
				ilosc_skokow_gracza[id]++;
		}
	}
	
	if(button & IN_ATTACK)
	{
		new Float:punchangle[3];
		
		if(informacje_przedmiotu_gracza[id][0] == 20)
			entity_set_vector(id, EV_VEC_punchangle, punchangle);
		if(informacje_przedmiotu_gracza[id][0] == 23)
		{
			entity_get_vector(id, EV_VEC_punchangle, punchangle);
			for(new i=0; i<3;i++) 
				punchangle[i]*=0.9;
			entity_set_vector(id, EV_VEC_punchangle, punchangle);
		}
	}
	
	if(informacje_przedmiotu_gracza[id][0] == 28 && button & IN_JUMP && button & IN_DUCK && flags & FL_ONGROUND && get_gametime() > informacje_przedmiotu_gracza[id][1]+4.0)
	{
		informacje_przedmiotu_gracza[id][1] = floatround(get_gametime());
		new Float:velocity[3];
		VelocityByAim(id, 700, velocity);
		velocity[2] = random_float(265.0,285.0);
		entity_set_vector(id, EV_VEC_velocity, velocity);
	}
	
	
	return FMRES_IGNORED;
 }

public Odrodzenie(id)
{
	if(!is_user_alive(id) || !is_user_connected(id))
		return PLUGIN_CONTINUE;
	
	if(nowa_klasa_gracza[id])
	{
		klasa_gracza[id] = nowa_klasa_gracza[id];
		nowa_klasa_gracza[id] = 0;
		strip_user_weapons(id);
		give_item(id, "weapon_knife");
		switch(get_user_team(id))
		{
			case 1: give_item(id, "weapon_glock18");
			case 2: give_item(id, "weapon_usp");
		}
		WczytajDane(id, klasa_gracza[id]);
	}
		
	if(!klasa_gracza[id])
	{
		WybierzKlase(id);
		return PLUGIN_CONTINUE;
	}
		
	switch(klasa_gracza[id])
	{
		case Snajper:
		{
			give_item(id, "weapon_awp");
			give_item(id, "weapon_scout");
			give_item(id, "weapon_deagle");
		}
		case Komandos:
		{
			give_item(id, "weapon_deagle");
		}
		case Strzelec:
		{
			give_item(id, "weapon_m4a1");
			give_item(id, "weapon_ak47");
		}
		case Obronca:
		{
			give_item(id, "weapon_m249");
			give_item(id, "weapon_hegrenade");
			give_item(id, "weapon_flashbang");				
			give_item(id, "weapon_smokegrenade");
		}
		case Medyk:
		{
			give_item(id, "weapon_ump45");
			ilosc_apteczek_gracza[id] = 2;
		}	
		case Wsparcie:
		{
			give_item(id, "weapon_mp5navy");
			ilosc_rakiet_gracza[id] = 3;
		}
		case Saper:
		{
			give_item(id, "weapon_p90");
			ilosc_min_gracza[id] = 4;
		}
		case Demolitions:
		{
			give_item(id, "weapon_aug");
			give_item(id, "weapon_hegrenade");
			give_item(id, "weapon_flashbang");
			give_item(id, "weapon_smokegrenade");
			ilosc_dynamitow_gracza[id] = 3;
		}
		case Rusher:
		{
			give_item(id, "weapon_m3");
			give_item(id, "weapon_deagle");
		}
		case Rambo:
		{
			give_item(id, "weapon_m4a1");
			give_item(id, "weapon_deagle");
			give_item(id, "weapon_hegrenade");
		}
		case Partyzant:
		{
			give_item(id, "weapon_p90");
			give_item(id, "weapon_flashbang");
			set_user_rendering(id, kRenderFxGlowShell, 0, 0, 0, kRenderTransColor, 70);
		}
		case Szpieg:
		{
			give_item(id, "weapon_deagle");
			ZmienUbranie(id, 0);
		}
		case Szturmowiec:
		{
			give_item(id, "weapon_m4a1");
			give_item(id, "weapon_deagle");
			give_item(id, "weapon_hegrenade");
		}
		case StrzelecWsparcia:
		{
			give_item(id, "weapon_g3sg1");
			ilosc_rakiet_gracza[id] = 1 ;
		}
		case LekkiZolnierz:
		{
			give_item(id, "weapon_galil");
			give_item(id, "weapon_p228");
		}
		case Rebeliant:
		{
			give_item(id, "weapon_sg552");
			give_item(id, "weapon_hegrenade");
			ilosc_min_gracza[id] = 1 ;
		}
		case Terrorysta:
		{
			give_item(id, "weapon_elite");	
			give_item(id, "weapon_ak47");
		}
		case Pirotechnik:
		{
			give_item(id, "weapon_deagle");
			give_item(id, "weapon_m4a1");
			give_item(id, "weapon_hegrenade");
			give_item(id, "weapon_flashbang");
			ilosc_rakiet_gracza[id] = 6 ;
		}
		case Morderca:
		{
			give_item(id, "weapon_ak47");
			give_item(id, "weapon_usp");
		}
		case Nozownik:
		{
			give_item(id, "weapon_glock");
			give_item(id, "weapon_hegrenade");
			give_item(id, "weapon_flashbang");
		}	
		case SWAT:
		{
			give_item(id, "weapon_m4a1");
			give_item(id, "weapon_hegrenade");
			give_item(id, "weapon_flashbang");
		}	
		case Zwiadowca:
		{
			give_item(id, "weapon_deagle");
			give_item(id, "weapon_famas");
			give_item(id, "weapon_hegrenade");
			give_item(id, "weapon_flashbang");
			set_user_rendering(id, kRenderFxGlowShell, 0, 0, 0, kRenderTransColor, 70);
		}
		case Principes:
		{
			give_item(id, "weapon_deagle");
		}
		case Kamikadze:
		{
			give_item(id, "weapon_awp");
			give_item(id, "weapon_deagle");
			ilosc_dynamitow_gracza[id] = 4 ;
		}
		case DrHouse:
		{
			give_item(id, "weapon_awp");
			give_item(id, "weapon_m4a1");	
			give_item(id, "weapon_ak47");
			give_item(id, "weapon_deagle");
			ilosc_rakiet_gracza[id] = 4 ;
		}
		case Nero:
		{
			give_item(id, "weapon_m3");
			give_item(id, "weapon_deagle");
			ilosc_dynamitow_gracza[id] = 3;
		}
		case Nokia:
		{
			give_item(id, "weapon_mp5");
			give_item(id, "weapon_p228");
			give_item(id, "weapon_hegrenade");
			ilosc_apteczek_gracza[id] = 8 ;
		}
		case Killer:
		{
			give_item(id, "weapon_knife");
		}
		case Kapral:
		{
			give_item(id, "weapon_famas");
			give_item(id, "weapon_usp");
		}
		case Deaglarz:
		{
			give_item(id, "weapon_deagle");
		}
		case Hitler:
		{
			give_item(id, "weapon_p228");
			give_item(id, "weapon_ak47");
			ilosc_min_gracza[id] = 2;
		}
		case Metalowiec:
		{
			give_item(id, "weapon_gail");
			give_item(id, "weapon_deagle");
			ilosc_rakiet_gracza[id] = 1;
		}
	}
		
	if(gracz_resetuje[id])
	{
		ResetujPunkty(id);
		gracz_resetuje[id] = false;
	}
	
	if(punkty_gracza[id]>0)
		PrzydzielPunkty(id);
			
	if(informacje_przedmiotu_gracza[id][0] == 10 || informacje_przedmiotu_gracza[id][0] == 9)
		give_item(id, "weapon_hegrenade");
			
	if(informacje_przedmiotu_gracza[id][0] == 9)
		ZmienUbranie(id, 0);
			
	if(informacje_przedmiotu_gracza[id][0] == 1)
		set_user_footsteps(id, 1);
	else
		set_user_footsteps(id, 0);
		
	if(informacje_przedmiotu_gracza[id][0] == 13)
		give_item(id, "weapon_awp");
		
	if(informacje_przedmiotu_gracza[id][0] == 19)
		informacje_przedmiotu_gracza[id][1] = 1;
	
	if(informacje_przedmiotu_gracza[id][0] == 27)
		informacje_przedmiotu_gracza[id][1] = 3;
			
	new weapons[32];
	new weaponsnum;
	get_user_weapons(id, weapons, weaponsnum);
	for(new i=0; i<weaponsnum; i++)
		if(is_user_alive(id))
			if(maxAmmo[weapons[i]] > 0)
				cs_set_user_bpammo(id, weapons[i], maxAmmo[weapons[i]]);
	
	redukcja_obrazen_gracza[id] = (47.3057*(1.0-floatpower( 2.7182, -0.06798*float(wytrzymalosc_gracza[id])))/100);
	maksymalne_zdrowie_gracza[id] = zdrowie_klasy[klasa_gracza[id]]+zdrowie_gracza[id]*2;
	szybkosc_gracza[id] = STANDARDOWA_SZYBKOSC*szybkosc_klasy[klasa_gracza[id]]+floatround(kondycja_gracza[id]*1.3);
	
	if(informacje_przedmiotu_gracza[id][0] == 18)
	{
		maksymalne_zdrowie_gracza[id] += 100;
		szybkosc_gracza[id] -= 0.4;
	}
		
	if(informacje_przedmiotu_gracza[id][0] == 25)
	{
		maksymalne_zdrowie_gracza[id] += 50;
		szybkosc_gracza[id] -= 0.3;
	}

	if(informacje_przedmiotu_gracza[id][0] == 30)
	{
		ilosc_rakiet_gracza[id] = 6;
	}

	if(informacje_przedmiotu_gracza[id][0] == 31)
	{
		maksymalne_zdrowie_gracza[id] += 200;
	}
	
	set_user_armor(id, pancerz_klasy[klasa_gracza[id]]);
	set_user_health(id, maksymalne_zdrowie_gracza[id]);
	if(informacje_przedmiotu_gracza[id][0] == 17)
		set_user_armor(id, 500);
		
	return PLUGIN_CONTINUE;
}

public PoczatekRundy()	
{
	freezetime = false;
	for(new id=0;id<=32;id++)
	{
		if(!is_user_alive(id))
			continue;
		
		set_task(0.1, "UstawSzybkosc", id+ZADANIE_USTAW_SZYBKOSC);
		
		switch(get_user_team(id))
		{
			case 1: client_cmd(id, "spk QTM_CodMod/start");
			case 2: client_cmd(id, "spk QTM_CodMod/start2");
		}
	}
}

public NowaRunda()
{
	freezetime = true;
	new iEnt = find_ent_by_class(-1, "Mine");
	while(iEnt > 0) 
	{
		remove_entity(iEnt);
		iEnt = find_ent_by_class(iEnt, "Mine");	
	}
}

public TakeDamage(this, idinflictor, idattacker, Float:damage, damagebits)
{
	if(!is_user_alive(this) || !is_user_connected(this) || informacje_przedmiotu_gracza[this][0] == 24 || !is_user_connected(idattacker) || get_user_team(this) == get_user_team(idattacker) || !klasa_gracza[idattacker])
		return HAM_IGNORED;
		
	new health = get_user_health(this);
	new weapon = get_user_weapon(idattacker);
	
	if(health < 2)
		return HAM_IGNORED;
	
	if(damagebits & DMG_BULLET)
	{
		if(informacje_przedmiotu_gracza[this][0] == 27 && informacje_przedmiotu_gracza[this][1]>0)
		{
			informacje_przedmiotu_gracza[this][1]--;
			return HAM_SUPERCEDE;
		}
		
		if(wytrzymalosc_gracza[this]>0)
			damage -= redukcja_obrazen_gracza[this]*damage;
		
		if(informacje_przedmiotu_gracza[this][0] == 2 || informacje_przedmiotu_gracza[this][0] == 3)
			damage-=(float(informacje_przedmiotu_gracza[this][1])<damage)? float(informacje_przedmiotu_gracza[this][1]): damage;
		
		if(informacje_przedmiotu_gracza[idattacker][0] == 5 && !UTIL_In_FOV(this, idattacker) && UTIL_In_FOV(idattacker, this))
			damage*=2.0;
		
		if(informacje_przedmiotu_gracza[idattacker][0] == 10)
			damage+=informacje_przedmiotu_gracza[idattacker][1];
		
		if(informacje_przedmiotu_gracza[this][0] == 12)
			damage-=(5.0<damage)? 5.0: damage;
		
		if(weapon == CSW_AWP && informacje_przedmiotu_gracza[idattacker][0] == 13)
			damage=float(health);
		
		if(informacje_przedmiotu_gracza[idattacker][0] == 21)
			damage+=10;
		
		if(informacje_przedmiotu_gracza[idattacker][0] == 22)
			damage+=20;
			
		if(informacje_przedmiotu_gracza[idattacker][0] == 29)
			damage+=30;
		if(weapon == CSW_KNIFE && informacje_przedmiotu_gracza[idattacker][0] == 32)
			damage=float(health);
		if(informacje_przedmiotu_gracza[idattacker][0] == 33)
			damage+=50;
		
		if(informacje_przedmiotu_gracza[this][0] == 26 && random_num(1, informacje_przedmiotu_gracza[this][1]) == 1)
		{
			SetHamParamEntity(3, this);
			SetHamParamEntity(1, idattacker);
		}
	}
	
	if(weapon == CSW_KNIFE && damagebits & DMG_SLASH)
	{
		if(informacje_przedmiotu_gracza[this][0] == 4)
			damage=damage*1.4+inteligencja_gracza[idattacker];
		if((informacje_przedmiotu_gracza[idattacker][0] == 8 || (klasa_gracza[idattacker] == Snajper && random(2) == 2) || klasa_gracza[idattacker] == Komandos) && !(get_user_button(idattacker) & IN_ATTACK))
			damage = float(health);
	}
		
	SetHamParamFloat(4, damage);
	return HAM_IGNORED;
}

public Damage(id)
{
	new attacker = get_user_attacker(id);
	new damage = read_data(2);
	if(!is_user_alive(attacker) || !is_user_connected(attacker) || id == attacker || !klasa_gracza[attacker])
		return PLUGIN_CONTINUE;
		
	if(informacje_przedmiotu_gracza[attacker][0] == 12 && random_num(1, informacje_przedmiotu_gracza[id][1]) == 1)
		Display_Fade(id,1<<14,1<<14 ,1<<16,255,155,50,230);
	
	if(get_user_team(id) != get_user_team(attacker))
	{
		while(damage>20)
		{
			damage-=20;
			doswiadczenie_gracza[attacker]++;
		}
	}
	SprawdzPoziom(attacker);
	return PLUGIN_CONTINUE;
}

public Death()
{
	new id = read_data(2);
	new attacker = read_data(1);
	
	if(!is_user_alive(attacker) || !is_user_connected(attacker))
		return PLUGIN_CONTINUE;
	
	new weapon = get_user_weapon(attacker);
	new zdrowie = get_user_health(attacker);
	
	if(get_user_team(id) != get_user_team(attacker) && klasa_gracza[attacker])
	{
		new nowe_doswiadczenie = 0;
		
		nowe_doswiadczenie += doswiadczenia_za_zabojstwo;
		
		if(klasa_gracza[id] == Rambo && klasa_gracza[attacker] != Rambo)
			nowe_doswiadczenie += doswiadczenia_za_zabojstwo*2;
		
		if(poziom_gracza[id] > poziom_gracza[attacker])
			nowe_doswiadczenie += poziom_gracza[id] - poziom_gracza[attacker];
		
		if(klasa_gracza[attacker] == Rambo || informacje_przedmiotu_gracza[attacker][0] == 15 && maxClip[weapon] != -1)
		{
	
			new nowe_zdrowie = (zdrowie+20<maksymalne_zdrowie_gracza[attacker])? zdrowie+20: maksymalne_zdrowie_gracza[attacker];
			set_user_clip(attacker, maxClip[weapon]);
			set_user_health(attacker, nowe_zdrowie);
		}
#if defined BOTY
		if(is_user_bot2(attacker) && random(9) == 0)
			WyrzucPrzedmiot(id);
#endif
		if(!informacje_przedmiotu_gracza[attacker][0])
			DajPrzedmiot(attacker, random_num(1, sizeof nazwy_przedmiotow-1));
	
		if(informacje_przedmiotu_gracza[attacker][0] == 14)
		{
			new nowe_zdrowie = (zdrowie+50<maksymalne_zdrowie_gracza[attacker])? zdrowie+50: maksymalne_zdrowie_gracza[attacker];
			set_user_health(attacker, nowe_zdrowie);
		}
		
		set_hudmessage(255, 212, 0, 0.50, 0.33, 1, 6.0, 4.0);
		ShowSyncHudMsg(attacker, SyncHudObj2, "+%i", nowe_doswiadczenie);
		
		doswiadczenie_gracza[attacker] += nowe_doswiadczenie;
	}
	
	SprawdzPoziom(attacker);
	
	if(informacje_przedmiotu_gracza[id][0] == 7 && random_num(1, informacje_przedmiotu_gracza[id][1]) == 1)
		set_task(0.1, "Wskrzes", id+ZADANIE_WSKRZES);
	
	return PLUGIN_CONTINUE;
}

public client_connect(id)
{
	//resetuje umiejetnosci
	klasa_gracza[id] = 0;
	poziom_gracza[id] = 0;
	doswiadczenie_gracza[id] = 0;
	punkty_gracza[id] = 0;
	zdrowie_gracza[id] = 0;
	inteligencja_gracza[id] = 0;
	wytrzymalosc_gracza[id] = 0;
	kondycja_gracza[id] = 0;
	maksymalne_zdrowie_gracza[id] = 0;
	szybkosc_gracza[id] = 0.0;

	
	get_user_name(id, nazwa_gracza[id], 63);
	
	remove_task(id+ZADANIE_POKAZ_INFORMACJE);
	remove_task(id+ZADANIE_POKAZ_REKLAME);	
	remove_task(id+ZADANIE_USTAW_SZYBKOSC);
	remove_task(id+ZADANIE_WSKRZES);
	remove_task(id+ZADANIE_WYSZKOLENIE_SANITARNE);
	
	set_task(10.0, "PokazReklame", id+ZADANIE_POKAZ_REKLAME);
	set_task(3.0, "PokazInformacje", id+ZADANIE_POKAZ_INFORMACJE);
	
	//resetuje przedmioty
	UsunPrzedmiot(id);
}

public client_disconnect(id)
{
	remove_task(id+ZADANIE_POKAZ_INFORMACJE);
	remove_task(id+ZADANIE_POKAZ_REKLAME);	
	remove_task(id+ZADANIE_USTAW_SZYBKOSC);
	remove_task(id+ZADANIE_WSKRZES);
	remove_task(id+ZADANIE_WYSZKOLENIE_SANITARNE);
		
	ZapiszDane(id);
	UsunPrzedmiot(id);
}
	
public RozbrajaBombe(id)
	if(klasa_gracza[id])
		rozbrajajacy = id;
	
public BombaPodlozona()
{
	new Players[32], playerCount, id;
	get_players(Players, playerCount, "aeh", "TERRORIST");
	
	if(get_playersnum() > 1)
	{
		doswiadczenie_gracza[podkladajacy] += doswiadczenie_za_bombe;
		for (new i=0; i<playerCount; i++) 
		{
			id = Players[i];
			if(!klasa_gracza[id])
				continue;
				
			if(id != podkladajacy)
			{
				doswiadczenie_gracza[id] += doswiadczenia_za_zabojstwo;
				client_print(id, print_chat, "[COD:MW] Dostales %i doswiadczenia za podlozenie bomby przez twoj team.", doswiadczenia_za_zabojstwo);
			}
			else
			{
				client_print(id, print_chat, "[COD:MW] Dostales %i doswiadczenia za podlozenie bomby.", doswiadczenie_za_bombe);
			}
			SprawdzPoziom(id);
		}
	}
}

public BombaRozbrojona()
{
	new Players[32], playerCount, id;
	get_players(Players, playerCount, "aeh", "CT");
	
	doswiadczenie_gracza[rozbrajajacy] += doswiadczenie_za_bombe;
	for (new i=0; i<playerCount; i++) 
	{
		id = Players[i];
		if(!klasa_gracza[id])
			continue;
		if(id != rozbrajajacy)
		{
			doswiadczenie_gracza[id]+= doswiadczenia_za_zabojstwo;
			client_print(id, print_chat, "[COD:MW] Dostales %i doswiadczenia za rozbrojenie bomby przez twoj team.", doswiadczenia_za_zabojstwo);
		}
		else
			client_print(id, print_chat, "[COD:MW] Dostales %i doswiadczenia za rozbrojenie bomby.",doswiadczenie_za_bombe);
		SprawdzPoziom(id);
	}
}

public OpisKlasy(id)
{
	new menu = menu_create("Wybierz klase:", "OpisKlasy_Handle");
	for(new i=1; i<sizeof nazwy_klas; i++)
		menu_additem(menu, nazwy_klas[i]);
	menu_setprop(menu, MPROP_EXITNAME, "Wyjdz");
	menu_setprop(menu, MPROP_BACKNAME, "Poprzednia strona");
	menu_setprop(menu, MPROP_NEXTNAME, "Nastepna strona");
	menu_display(id, menu);
	
	client_cmd(id, "spk QTM_CodMod/select");
}

public OpisKlasy_Handle(id, menu, item)
{
	client_cmd(id, "spk QTM_CodMod/select");
	
	if(item == MENU_EXIT)
	{
		menu_destroy(menu);
		return PLUGIN_CONTINUE;
	}
	client_print(id, print_chat, "[COD:MW] %s: %s", nazwy_klas[item+1], opisy_klas[item+1]);
	menu_display(id, menu);
	
	return PLUGIN_CONTINUE;
}

public WybierzKlase(id)
{
	new menu = menu_create("Wybierz klase:", "WybierzKlase_Handle");
	new klasa[50];
	for(new i=1; i<sizeof nazwy_klas; i++)
	{
		WczytajDane(id, i);
		format(klasa, 49, "%s \yPoziom: %i", nazwy_klas[i], poziom_gracza[id]);
		menu_additem(menu, klasa);
	}
	
	WczytajDane(id, klasa_gracza[id]);
	
	menu_setprop(menu, MPROP_EXITNAME, "Wyjdz");
	menu_setprop(menu, MPROP_BACKNAME, "Poprzednia strona");
	menu_setprop(menu, MPROP_NEXTNAME, "Nastepna strona");
	menu_display(id, menu);
		
	client_cmd(id, "spk QTM_CodMod/select");
#if defined BOTY
	if(is_user_bot2(id))
		WybierzKlase_Handle(id, menu, random(sizeof nazwy_klas-1));
#endif
}

public WybierzKlase_Handle(id, menu, item)
{
	client_cmd(id, "spk QTM_CodMod/select");
	
	if(item == MENU_EXIT)
	{
		menu_destroy(menu);
		return PLUGIN_CONTINUE;
	}	
		
	item++;
	
	if(item == klasa_gracza[id])
		return PLUGIN_CONTINUE;
	
	if(item == Rambo && !(get_user_flags(id) & ADMIN_KICK))
        if(item == DrHouse && !(get_user_flags(id) & ADMIN_KICK))
        if(item == Hitler && !(get_user_flags(id) & ADMIN_KICK))
       
	{
		client_print(id, print_chat, "[COD:MW] Synek Nie Bierz Sie Za Rambo Nie Jest Ono Dla Cb..");
		WybierzKlase(id);
		return PLUGIN_CONTINUE;
	}
	
	if(klasa_gracza[id])
	{
		nowa_klasa_gracza[id] = item;
		client_print(id, print_chat, "[COD:MW] Klasa zostanie zmieniona w nastepnej rundzie.");
	}
	else
	{
		klasa_gracza[id] = item;
		WczytajDane(id, klasa_gracza[id]);
		Odrodzenie(id);
	}
	return PLUGIN_CONTINUE;
}

public PrzydzielPunkty(id)
{
	new inteligencja[500];
	new zdrowie[500];
	new wytrzymalosc[500];
	new kondycja[500];
	new tytul[25];
	format(inteligencja, 64, "Inteligencja: \r%i \y(Zwieksza obrazenia zadawane przedmiotami)", inteligencja_gracza[id]);
	format(zdrowie, 59, "Zycie: \r%i \y(Zwieksza zycie)", zdrowie_gracza[id]);
	format(wytrzymalosc, 59, "Wytrzymalosc: \r%i \y(Zmniejsza obrazenia)", wytrzymalosc_gracza[id]);
	format(kondycja, 59, "Kondycja: \r%i \y(Zwieksza tempo chodu)", kondycja_gracza[id]);
	format(tytul, 24, "Przydziel Punkty(%i):", punkty_gracza[id]);
	new menu = menu_create(tytul, "PrzydzielPunkty_Handler");
	menu_additem(menu, inteligencja);
	menu_additem(menu, zdrowie);
	menu_additem(menu, wytrzymalosc);
	menu_additem(menu, kondycja);
	menu_display(id, menu);
#if defined BOTY
	if(is_user_bot2(id))
		PrzydzielPunkty_Handler(id, menu, random(4));
#endif
}

public PrzydzielPunkty_Handler(id, menu, item)
{
	client_cmd(id, "spk QTM_CodMod/select");
	
	if(item == MENU_EXIT)
	{
		menu_destroy(menu);
		return PLUGIN_CONTINUE;
	}
	
	switch(item) 
	{ 
		case 0: 
		{	
			if(inteligencja_gracza[id]<400)
				inteligencja_gracza[id]++;
			else 
				client_print(id, print_chat, "[COD:MW] Maxymalny poziom inteligencji osiagniety");
			
		}
		case 1: 
		{	
			if(zdrowie_gracza[id]<400)
				zdrowie_gracza[id]++;
			else 
				client_print(id, print_chat, "[COD:MW] No Synek Wiecej Nie Wbijesz.Kawa Dobrej Roboty");
		}
		case 2: 
		{	
			if(wytrzymalosc_gracza[id]<400)
				wytrzymalosc_gracza[id]++;
			else 
				client_print(id, print_chat, "[COD:MW] No Synek Wiecej Nie Wbijesz.Kawa Dobrej Roboty");
			
		}
		case 3: 
		{	
			if(kondycja_gracza[id]<400)
				kondycja_gracza[id]++;
			else 
				client_print(id, print_chat, "[COD:MW] No Synek Wiecej Nie Wbijesz.Kawa Dobrej Roboty");
		}
	}
	
	punkty_gracza[id]--;
	
	if(punkty_gracza[id]>0)
		PrzydzielPunkty(id);
		
	return PLUGIN_CONTINUE;
}

public ResetujPunkty(id)
{	
	punkty_gracza[id] = poziom_gracza[id]*2-2;
	inteligencja_gracza[id] = 0;
	zdrowie_gracza[id] = 0;
	kondycja_gracza[id] = 0;
	wytrzymalosc_gracza[id] = 0;
}

public KomendaResetujPunkty(id)
{	
	client_print(id, print_chat, "[COD:MW] Umiejetnosci zostana zresetowane w nastepnej rundzie.");
	client_cmd(id, "spk QTM_CodMod/select");
	gracz_resetuje[id] = true;
}

public WyszkolenieSanitarne(id)
{
	id -= ZADANIE_WYSZKOLENIE_SANITARNE;
	if(informacje_przedmiotu_gracza[id][0] != 16)
		return PLUGIN_CONTINUE;
	set_task(5.0, "WyszkolenieSanitarne", id+ZADANIE_WYSZKOLENIE_SANITARNE);
	if(!is_user_alive(id))
		return PLUGIN_CONTINUE;
	new health = get_user_health(id);
	new new_health = (health+10<maksymalne_zdrowie_gracza[id])?health+10:maksymalne_zdrowie_gracza[id];
	set_user_health(id, new_health);
	return PLUGIN_CONTINUE;
}

public StworzApteczke(id)
{
	if (!ilosc_apteczek_gracza[id])
	{
		client_print(id, print_center, "Masz tylko 2 apteczki na runde!");
		return PLUGIN_CONTINUE;
	}
	
	if(inteligencja_gracza[id] < 1)
		client_print(id, print_center, "Aby wzmocnic apteczke, zwieksz inteligencje!");
		
	ilosc_apteczek_gracza[id]--;
	
	new Float:origin[3];
	entity_get_vector(id, EV_VEC_origin, origin);
	
	new ent = create_entity("info_target");
	entity_set_string(ent, EV_SZ_classname, "Apteczka");
	entity_set_edict(ent, EV_ENT_owner, id);
	entity_set_int(ent, EV_INT_solid, SOLID_NOT);
	entity_set_vector(ent, EV_VEC_origin, origin);
	entity_set_float(ent, EV_FL_ltime, halflife_time() + 7 + 0.1);
	
	
	entity_set_model(ent, "models/w_medkit.mdl");
	set_rendering ( ent, kRenderFxGlowShell, 255,0,0, kRenderFxNone, 255 ) 	;
	drop_to_floor(ent);
	
	entity_set_float(ent, EV_FL_nextthink, halflife_time() + 0.1);
	
	return PLUGIN_CONTINUE;
}

public ApteczkaThink(ent)
{
	new id = entity_get_edict(ent, EV_ENT_owner);
	new totem_dist = 300;
	new totem_heal = 5+floatround(inteligencja_gracza[id]*0.5);
	if (entity_get_edict(ent, EV_ENT_euser2) == 1)
	{		
		new Float:forigin[3], origin[3];
		entity_get_vector(ent, EV_VEC_origin, forigin);
		FVecIVec(forigin,origin);
		
		new entlist[33];
		new numfound = find_sphere_class(0,"player",totem_dist+0.0,entlist, 32,forigin);
		
		for (new i=0; i < numfound; i++)
		{		
			new pid = entlist[i];
			
			if (get_user_team(pid) != get_user_team(id))
				continue;
								
			new zdrowie = get_user_health(pid);
			new nowe_zdrowie = (zdrowie+totem_heal<maksymalne_zdrowie_gracza[pid])?zdrowie+totem_heal:maksymalne_zdrowie_gracza[pid];
			if (is_user_alive(pid)) set_user_health(pid, nowe_zdrowie);		
		}
		
		entity_set_edict(ent, EV_ENT_euser2, 0);
		entity_set_float(ent, EV_FL_nextthink, halflife_time() + 1.5);
		
		return PLUGIN_CONTINUE;
	}
	
	if (entity_get_float(ent, EV_FL_ltime) < halflife_time() || !is_user_alive(id))
	{
		remove_entity(ent);
		return PLUGIN_CONTINUE;
	}
	
	if (entity_get_float(ent, EV_FL_ltime)-2.0 < halflife_time())
		set_rendering ( ent, kRenderFxNone, 255,255,255, kRenderTransAlpha, 100 ) ;
		
	new Float:forigin[3], origin[3];
	entity_get_vector(ent, EV_VEC_origin, forigin);
	FVecIVec(forigin,origin);
					
	//Find people near and give them health
	message_begin( MSG_BROADCAST, SVC_TEMPENTITY, origin );
	write_byte( TE_BEAMCYLINDER );
	write_coord( origin[0] );
	write_coord( origin[1] );
	write_coord( origin[2] );
	write_coord( origin[0] );
	write_coord( origin[1] + totem_dist );
	write_coord( origin[2] + totem_dist );
	write_short( sprite_white );
	write_byte( 0 ); // startframe
	write_byte( 0 ); // framerate
	write_byte( 10 ); // life
	write_byte( 10 ); // width
	write_byte( 255 ); // noise
	write_byte( 255 ); // r, g, b
	write_byte( 100 );// r, g, b
	write_byte( 100 ); // r, g, b
	write_byte( 128 ); // brightness
	write_byte( 5 ); // speed
	message_end();
		
	entity_set_edict(ent, EV_ENT_euser2 ,1);
	entity_set_float(ent, EV_FL_nextthink, halflife_time() + 0.5);
	
		
	return PLUGIN_CONTINUE;

}

public StworzRakiete(id)
{
	if (!ilosc_rakiet_gracza[id])
	{
		client_print(id, print_center, "Synek Koniec Rakiet..");
		return PLUGIN_CONTINUE;
	}
	
	if(poprzednia_rakieta_gracza[id] + 1.0 > get_gametime())
	{
		client_print(id, print_center, "Rakiet mozesz uzywac co 1 sekunde!");
		return PLUGIN_CONTINUE;
	}
	
	if (is_user_alive(id))
	{	
		if(inteligencja_gracza[id] < 1)
			client_print(id, print_center, "Aby wzmocnic rakiete, zwieksz inteligencje!");
			
		poprzednia_rakieta_gracza[id] = get_gametime();
		ilosc_rakiet_gracza[id]--;

		new Float: Origin[3], Float: vAngle[3], Float: Velocity[3];
		
		entity_get_vector(id, EV_VEC_v_angle, vAngle);
		entity_get_vector(id, EV_VEC_origin , Origin);
	
		new Ent = create_entity("info_target");
	
		entity_set_string(Ent, EV_SZ_classname, "Rocket");
		entity_set_model(Ent, "models/rpgrocket.mdl");
	
		vAngle[0] *= -1.0;
	
		entity_set_origin(Ent, Origin);
		entity_set_vector(Ent, EV_VEC_angles, vAngle);
	
		entity_set_int(Ent, EV_INT_effects, 2);
		entity_set_int(Ent, EV_INT_solid, SOLID_BBOX);
		entity_set_int(Ent, EV_INT_movetype, MOVETYPE_FLY);
		entity_set_edict(Ent, EV_ENT_owner, id);
	
		VelocityByAim(id, 1000 , Velocity);
		entity_set_vector(Ent, EV_VEC_velocity ,Velocity);
	}	
	return PLUGIN_CONTINUE;
}

public PolozDynamit(id)
{
	if(!ilosc_dynamitow_gracza[id])
	{
		client_print(id, print_center, "Synek Nie Masz Juz Dynamitu.!");
		return PLUGIN_CONTINUE;
	}
	
	if(inteligencja_gracza[id] < 1)
		client_print(id, print_center, "Aby wzmocnic dynamit, zwieksz inteligencje!");
	
	ilosc_dynamitow_gracza[id]--;
	new Float:fOrigin[3], iOrigin[3];
	entity_get_vector( id, EV_VEC_origin, fOrigin);
	iOrigin[0] = floatround(fOrigin[0]);
	iOrigin[1] = floatround(fOrigin[1]);
	iOrigin[2] = floatround(fOrigin[2]);

	message_begin(MSG_BROADCAST,SVC_TEMPENTITY, iOrigin);
	write_byte(TE_EXPLOSION);
	write_coord(iOrigin[0]);
	write_coord(iOrigin[1]);
	write_coord(iOrigin[2]);
	write_short(sprite_blast);
	write_byte(32);
	write_byte(20);
	write_byte(0);
	message_end();
	
	message_begin( MSG_BROADCAST, SVC_TEMPENTITY, iOrigin );
	write_byte( TE_BEAMCYLINDER );
	write_coord( iOrigin[0] );
	write_coord( iOrigin[1] );
	write_coord( iOrigin[2] );
	write_coord( iOrigin[0] );
	write_coord( iOrigin[1] + 300 );
	write_coord( iOrigin[2] + 300 );
	write_short( sprite_white );
	write_byte( 0 ); // startframe
	write_byte( 0 ); // framerate
	write_byte( 10 ); // life
	write_byte( 10 ); // width
	write_byte( 255 ); // noise
	write_byte( 255 ); // r, g, b
	write_byte( 100 );// r, g, b
	write_byte( 100 ); // r, g, b
	write_byte( 128 ); // brightness
	write_byte( 8 ); // speed
	message_end();

	new entlist[33];
	new numfound = find_sphere_class(id, "player", 300.0 , entlist, 32);
	
	for (new i=0; i < numfound; i++)
	{		
		new pid = entlist[i];
		
		if (!is_user_alive(pid) || get_user_team(id) == get_user_team(pid) || informacje_przedmiotu_gracza[pid][0] == 24)
			continue;
		ExecuteHam(Ham_TakeDamage, pid, 0, id, 90.0+float(inteligencja_gracza[id]) , 1);
	}
	return PLUGIN_CONTINUE;
}

public PostawMine(id)
{
	if (!ilosc_min_gracza[id])
	{
		client_print(id, print_center, "Synek Nie Masz Juz Min.!");
		return PLUGIN_CONTINUE;
	}
	
	if(inteligencja_gracza[id] < 1)
		client_print(id, print_center, "Aby wzmocnic miny, zwieksz inteligencje!");
	
	ilosc_min_gracza[id]--;
	
	new Float:origin[3];
	entity_get_vector(id, EV_VEC_origin, origin);
		
	new ent = create_entity("info_target");
	entity_set_string(ent ,EV_SZ_classname, "Mine");
	entity_set_edict(ent ,EV_ENT_owner, id);
	entity_set_int(ent, EV_INT_movetype, MOVETYPE_TOSS);
	entity_set_origin(ent, origin);
	entity_set_int(ent, EV_INT_solid, SOLID_BBOX);
	
	entity_set_model(ent, "models/mine.mdl");
	entity_set_size(ent,Float:{-16.0,-16.0,0.0},Float:{16.0,16.0,2.0});
	
	drop_to_floor(ent);

	entity_set_float(ent,EV_FL_nextthink,halflife_time() + 0.01) ;
	
	set_rendering(ent,kRenderFxNone, 0,0,0, kRenderTransTexture,50)	;
	
	
	return PLUGIN_CONTINUE;
}

public DotykMiny(ent, id)
{
	new attacker = entity_get_edict(ent, EV_ENT_owner);
	if (get_user_team(attacker) != get_user_team(id))
	{
		new Float:fOrigin[3], iOrigin[3];
		entity_get_vector( ent, EV_VEC_origin, fOrigin);
		iOrigin[0] = floatround(fOrigin[0]);
		iOrigin[1] = floatround(fOrigin[1]);
		iOrigin[2] = floatround(fOrigin[2]);
		
		message_begin(MSG_BROADCAST,SVC_TEMPENTITY, iOrigin);
		write_byte(TE_EXPLOSION);
		write_coord(iOrigin[0]);
		write_coord(iOrigin[1]);
		write_coord(iOrigin[2]);
		write_short(sprite_blast);
		write_byte(32); // scale
		write_byte(20); // framerate
		write_byte(0);// flags
		message_end();
		new entlist[33];
		new numfound = find_sphere_class(ent,"player", 90.0 ,entlist, 32);
		
		for (new i=0; i < numfound; i++)
		{		
			new pid = entlist[i];
			
			if (!is_user_alive(pid) || get_user_team(attacker) == get_user_team(pid) || informacje_przedmiotu_gracza[pid][0] == 24 || klasa_gracza[id] == Obronca)
				continue;
				
			ExecuteHam(Ham_TakeDamage, pid, ent, attacker, 90.0+float(inteligencja_gracza[attacker]) , 1);
		}
		remove_entity(ent);
	}
}

public DotykRakiety(ent)
{
	if ( !is_valid_ent(ent))
		return;

	new attacker = entity_get_edict(ent, EV_ENT_owner);

	new Float:fOrigin[3], iOrigin[3];
	entity_get_vector( ent, EV_VEC_origin, fOrigin);	
	iOrigin[0] = floatround(fOrigin[0]);
	iOrigin[1] = floatround(fOrigin[1]);
	iOrigin[2] = floatround(fOrigin[2]);

	message_begin(MSG_BROADCAST,SVC_TEMPENTITY, iOrigin);
	write_byte(TE_EXPLOSION);
	write_coord(iOrigin[0]);
	write_coord(iOrigin[1]);
	write_coord(iOrigin[2]);
	write_short(sprite_blast);
	write_byte(32); // scale
	write_byte(20); // framerate
	write_byte(0);// flags
	message_end();

	new entlist[33];
	new numfound = find_sphere_class(ent, "player", 230.0, entlist, 32);
	
	for (new i=0; i < numfound; i++)
	{		
		new pid = entlist[i];
		
		if (!is_user_alive(pid) || get_user_team(attacker) == get_user_team(pid) || informacje_przedmiotu_gracza[pid][0] == 24)
			continue;
		ExecuteHam(Ham_TakeDamage, pid, ent, attacker, 55.0+float(inteligencja_gracza[attacker]) , 1);
	}
	remove_entity(ent);
}	

public CurWeapon(id)
{
	if(freezetime || !klasa_gracza[id])
		return PLUGIN_CONTINUE;
		
	new weapon = read_data(2);

	UstawSzybkosc(id);
	
	if(weapon == CSW_C4)
		podkladajacy = id;
	return PLUGIN_CONTINUE;
}

public EmitSound(id, iChannel, szSound[], Float:fVol, Float:fAttn, iFlags, iPitch ) 
{
	if(equal(szSound, "common/wpn_denyselect.wav"))
	{
		UzyjPrzedmiotu(id);
		return FMRES_SUPERCEDE;
	}
	
	return FMRES_IGNORED;
}

public UzyjPrzedmiotu(id)
{
	if(informacje_przedmiotu_gracza[id][0] == 19 && informacje_przedmiotu_gracza[id][1]>0) 
	{
		set_user_health(id, maksymalne_zdrowie_gracza[id]);
		informacje_przedmiotu_gracza[id][1]--;
	}
	
	if(ilosc_apteczek_gracza[id]>0)
		StworzApteczke(id);
	if(ilosc_rakiet_gracza[id]>0)
		StworzRakiete(id);
	if(ilosc_min_gracza[id]>0)
		PostawMine(id);
	if(ilosc_dynamitow_gracza[id]>0)
		PolozDynamit(id);
		
	return PLUGIN_HANDLED;
}

public ZapiszDane(id)
{
	new vaultkey[64],vaultdata[256];
	format(vaultkey,63,"%s-%i-cod", nazwa_gracza[id], klasa_gracza[id]);
	format(vaultdata,255,"%i#%i#%i#%i#%i#%i", doswiadczenie_gracza[id], poziom_gracza[id], inteligencja_gracza[id], zdrowie_gracza[id], wytrzymalosc_gracza[id], kondycja_gracza[id]);
	nvault_set(g_vault,vaultkey,vaultdata);
}

public WczytajDane(id, klasa)
{
	new vaultkey[64],vaultdata[256];
	format(vaultkey,63,"%s-%i-cod", nazwa_gracza[id], klasa);
	format(vaultdata,255,"%i#%i#%i#%i#%i#%i", doswiadczenie_gracza[id], poziom_gracza[id], inteligencja_gracza[id], zdrowie_gracza[id], wytrzymalosc_gracza[id], kondycja_gracza[id]);
	nvault_get(g_vault,vaultkey,vaultdata,255);
 
	replace_all(vaultdata, 255, "#", " ");
 
	new doswiadczeniegracza[32], poziomgracza[32], inteligencjagracza[32], silagracza[32], zrecznoscgracza[32], zwinnoscgracza[32];
 
	parse(vaultdata, doswiadczeniegracza, 31, poziomgracza, 31, inteligencjagracza, 31, silagracza, 31, zrecznoscgracza, 31, zwinnoscgracza, 31);
 
	doswiadczenie_gracza[id] = str_to_num(doswiadczeniegracza);
	poziom_gracza[id] = str_to_num(poziomgracza)>0?str_to_num(poziomgracza):1;
	inteligencja_gracza[id] = str_to_num(inteligencjagracza);
	zdrowie_gracza[id] = str_to_num(silagracza);
	wytrzymalosc_gracza[id] = str_to_num(zrecznoscgracza);
	kondycja_gracza[id] = str_to_num(zwinnoscgracza);
	punkty_gracza[id] = (poziom_gracza[id]-1)*2-inteligencja_gracza[id]-zdrowie_gracza[id]-wytrzymalosc_gracza[id]-kondycja_gracza[id];
} 

public WyrzucPrzedmiot(id)
{
	if(informacje_przedmiotu_gracza[id][0])
	{
		client_print(id, print_chat, "[COD:MW] Wyrzuciles %s.", nazwy_przedmiotow[informacje_przedmiotu_gracza[id][0]]);
		UsunPrzedmiot(id);
	}
	else
		client_print(id, print_chat, "[COD:MW] Nie masz zadnego przedmiotu.", nazwy_przedmiotow[informacje_przedmiotu_gracza[id][0]]);
}

public UsunPrzedmiot(id)
{
	informacje_przedmiotu_gracza[id][0] = 0;
	informacje_przedmiotu_gracza[id][1] = 0;
	if(is_user_alive(id))
	{
		set_user_footsteps(id, 0);
		set_rendering(id,kRenderFxGlowShell,0,0,0 ,kRenderTransAlpha, 255);
	}
	ZmienUbranie(id, 1);
}

public DajPrzedmiot(id, przedmiot)
{
	UsunPrzedmiot(id);
	informacje_przedmiotu_gracza[id][0] = przedmiot;
	client_print(id, print_chat, "[COD:MW] Zdobyles %s.", nazwy_przedmiotow[informacje_przedmiotu_gracza[id][0]]);	
	
	switch(przedmiot)
	{
		case 1:
		{
			set_user_footsteps(id, 1);
		}
		case 2:
		{
			informacje_przedmiotu_gracza[id][1] = random_num(3,6);
		}
		case 3:
		{
			informacje_przedmiotu_gracza[id][1] = random_num(6, 11);
		}
		case 5:
		{
			informacje_przedmiotu_gracza[id][1] = random_num(6, 9);
		}
		case 6:
		{
			informacje_przedmiotu_gracza[id][1] = random_num(100, 150);
			if(is_user_alive(id))
				set_rendering(id,kRenderFxGlowShell,0,0,0 ,kRenderTransAlpha, informacje_przedmiotu_gracza[id][1]);
		}
		case 7:
		{
			informacje_przedmiotu_gracza[id][1] = random_num(2, 4);
		}
		case 8:
		{
			if(klasa_gracza[id] == Komandos)
				DajPrzedmiot(id, random_num(1, sizeof nazwy_przedmiotow-1));
		}
		case 9:
		{
			informacje_przedmiotu_gracza[id][1] = random_num(1, 3);
			ZmienUbranie(id, 0);
			if(is_user_alive(id))
				give_item(id, "weapon_hegrenade");
		}
		case 10:
		{
			informacje_przedmiotu_gracza[id][1] = random_num(4, 8);
			if(is_user_alive(id))
				give_item(id, "weapon_hegrenade");
		}
		case 12:
		{
			informacje_przedmiotu_gracza[id][1] = random_num(1, 4);
		}
		case 13:
		{
			if(is_user_alive(id))
				give_item(id, "weapon_awp");
		}
		case 15:
		{
			if(klasa_gracza[id] == Rambo)
				DajPrzedmiot(id, random_num(1, sizeof nazwy_przedmiotow-1));
		}
		case 16:
		{
			set_task(5.0, "WyszkolenieSanitarne", id+ZADANIE_WYSZKOLENIE_SANITARNE);
		}
		case 19:
		{
			informacje_przedmiotu_gracza[id][1] = 1;
		}
		case 26:
		{
			informacje_przedmiotu_gracza[id][1] = random_num(3, 6);
		}
		case 27:
		{
			informacje_przedmiotu_gracza[id][1] = 3;
		}
	}
}
	
public OpisPrzedmiotu(id)
{
	new opis_przedmiotu[128];
	new losowa_wartosc[3];
	num_to_str(informacje_przedmiotu_gracza[id][1], losowa_wartosc, 2);
	format(opis_przedmiotu, 127, opisy_przedmiotow[informacje_przedmiotu_gracza[id][0]]);
	replace_all(opis_przedmiotu, 127, "LW", losowa_wartosc);
	
	client_print(id, print_chat, "Przedmiot: %s.", nazwy_przedmiotow[informacje_przedmiotu_gracza[id][0]]);
	client_print(id, print_chat, "Opis: %s.", opis_przedmiotu);
}

public Wskrzes(id)
{
	id-=ZADANIE_WSKRZES;
	ExecuteHamB(Ham_CS_RoundRespawn, id);
}

public SprawdzPoziom(id)
{	
	if(poziom_gracza[id] < 1000)
	{
		while(doswiadczenie_gracza[id] >= doswiadczenie_poziomu[poziom_gracza[id]])
		{
			poziom_gracza[id]++;
			set_hudmessage(60, 200, 25, -1.0, 0.25, 0, 1.0, 2.0, 0.1, 0.2, 2);
			ShowSyncHudMsg(id, SyncHudObj3, "Awansowales do nastepnego poziomu!");
			client_cmd(id, "spk QTM_CodMod/levelup");
		}
	
		punkty_gracza[id] = (poziom_gracza[id]-1)*2-inteligencja_gracza[id]-zdrowie_gracza[id]-wytrzymalosc_gracza[id]-kondycja_gracza[id];
	}
	ZapiszDane(id);
}

public PokazInformacje(id) 
{
	id -= ZADANIE_POKAZ_INFORMACJE;
	
	set_task(0.1, "PokazInformacje", id+ZADANIE_POKAZ_INFORMACJE);
		
	if(!is_user_alive(id))
	{
		new target = entity_get_int(id, EV_INT_iuser2);
		
		if(target == 0)
			return PLUGIN_CONTINUE;
			
		set_hudmessage(255, 255, 255, 0.6, -1.0, 0, 0.0, 0.3, 0.0, 0.0, 2);
		ShowSyncHudMsg(id, SyncHudObj, "Klasa : %s^nDoswiadczenie : %i / %i^nPoziom : %i^nPrzedmiot : %s", nazwy_klas[klasa_gracza[target]], doswiadczenie_gracza[target], doswiadczenie_poziomu[poziom_gracza[target]], poziom_gracza[target], nazwy_przedmiotow[informacje_przedmiotu_gracza[target][0]]);
		
		return PLUGIN_CONTINUE;
	}
	set_hudmessage(255, 0, 0, 0.02, 0.23, 0, 0.0, 0.3, 0.0, 0.0);
	ShowSyncHudMsg(id, SyncHudObj, "[Klasa : %s]^n[Doswiadczenie : %i / %i]^n[Poziom : %i]^n[Przedmiot : %s]", nazwy_klas[klasa_gracza[id]], doswiadczenie_gracza[id], doswiadczenie_poziomu[poziom_gracza[id]], poziom_gracza[id], nazwy_przedmiotow[informacje_przedmiotu_gracza[id][0]]);
	return PLUGIN_CONTINUE;
}  

public PokazReklame(id)
{
	id-=ZADANIE_POKAZ_REKLAME;
	client_print(id, print_chat, "[COD:MW] Witaj w Modyfikacji Call of Duty stworzonej przez QTM_Peyote.");
}

public UstawSzybkosc(id)
{
	id -= id>32? ZADANIE_USTAW_SZYBKOSC: 0;
	
	if(klasa_gracza[id])
		set_user_maxspeed(id, szybkosc_gracza[id]);
}
	
public ZmienUbranie(id,reset)
{
	if (id<1 || id>32 || !is_user_connected(id)) 
		return PLUGIN_CONTINUE;
	
	if (reset)
		cs_reset_user_model(id);
	else
	{
		new num = random_num(0,3);
		switch(get_user_team(id))
		{
			case 1: cs_set_user_model(id, Ubrania_CT[num]);
			case 2:cs_set_user_model(id, Ubrania_Terro[num]);
		}
	}
	
	return PLUGIN_CONTINUE;
}

public Pomoc()
{
	switch(random(6))
	{
		case 0: client_print(0, print_chat, "[COD:MW] Aby zresetowac umiejetnosci napisz /reset.");
		case 1: client_print(0, print_chat, "[COD:MW] Aby zmienic klase napisz /klasa.");
		case 2: client_print(0, print_chat, "[COD:MW] Aby uzyc przedmiotu nacisnij E.");
		case 3: client_print(0, print_chat, "[COD:MW] Aby wyrzucic przedmiot napisz /wyrzuc.");
		case 4: client_print(0, print_chat, "[COD:MW] Aby zobaczyc opis przedmiotu napisz /przedmiot.");
		case 5: client_print(0, print_chat, "[COD:MW] Aby zobaczyc opis klas napisz /klasy.");
	}
	set_task(36.0, "Pomoc");
}

public cmd_setlvl(id, level, cid)
{
		if(!cmd_access(id,level,cid,3))
				return PLUGIN_HANDLED;
		new arg1[33];
		new arg2[6];
		read_argv(1, arg1, 32);
		read_argv(2, arg2, 5);
		new player = cmd_target(id, arg1, 0); //Dodane 0. Admin z flag "A" te dostanie level thx. G[o]Q
		new value = str_to_num(arg2)-1;
		
		doswiadczenie_gracza[player] = doswiadczenie_poziomu[value];
		poziom_gracza[player] = 0;
		SprawdzPoziom(player);
		return PLUGIN_HANDLED;
}

public DotykBroni(weapon,id)
{
	new model[23];
	entity_get_string(weapon, EV_SZ_model, model, 22);
	if (!is_user_connected(id) || entity_get_edict(weapon, EV_ENT_owner) == id || equal(model, "models/w_backpack.mdl"))
		return HAM_IGNORED;
	return HAM_SUPERCEDE;
}

public BlokujKomende()
	return PLUGIN_HANDLED;
	
stock bool:UTIL_In_FOV(id,target)
{
	if (Find_Angle(id,target,9999.9) > 0.0)
		return true;
	
	return false;
}
#if defined BOTY
public is_user_bot2(id)
{
	new ping, loss
	get_user_ping(id, ping, loss)
	if(ping > 0 && loss > 0)
		return false
	return true
}
#endif

stock Float:Find_Angle(Core,Target,Float:dist)
{
	new Float:vec2LOS[2];
	new Float:flDot;
	new Float:CoreOrigin[3];
	new Float:TargetOrigin[3];
	new Float:CoreAngles[3];
	
	pev(Core,pev_origin,CoreOrigin);
	pev(Target,pev_origin,TargetOrigin);
	
	if (get_distance_f(CoreOrigin,TargetOrigin) > dist)
		return 0.0;
	
	pev(Core,pev_angles, CoreAngles);
	
	for ( new i = 0; i < 2; i++ )
		vec2LOS[i] = TargetOrigin[i] - CoreOrigin[i];
	
	new Float:veclength = Vec2DLength(vec2LOS);
	
	//Normalize V2LOS
	if (veclength <= 0.0)
	{
		vec2LOS[0] = 0.0;
		vec2LOS[1] = 0.0;
	}
	else
	{
		new Float:flLen = 1.0 / veclength;
		vec2LOS[0] = vec2LOS[0]*flLen;
		vec2LOS[1] = vec2LOS[1]*flLen;
	}
	
	//Do a makevector to make v_forward right
	engfunc(EngFunc_MakeVectors,CoreAngles);
	
	new Float:v_forward[3];
	new Float:v_forward2D[2];
	get_global_vector(GL_v_forward, v_forward);
	
	v_forward2D[0] = v_forward[0];
	v_forward2D[1] = v_forward[1];
	
	flDot = vec2LOS[0]*v_forward2D[0]+vec2LOS[1]*v_forward2D[1];
	
	if ( flDot > 0.5 )
	{
		return flDot;
	}
	
	return 0.0;
}

stock Float:Vec2DLength( Float:Vec[2] )  
{ 
	return floatsqroot(Vec[0]*Vec[0] + Vec[1]*Vec[1] );
}

stock Display_Fade(id,duration,holdtime,fadetype,red,green,blue,alpha)
{
	message_begin( MSG_ONE, g_msg_screenfade,{0,0,0},id );
	write_short( duration );	// Duration of fadeout
	write_short( holdtime );	// Hold time of color
	write_short( fadetype );	// Fade type
	write_byte ( red );		// Red
	write_byte ( green );		// Green
	write_byte ( blue );		// Blue
	write_byte ( alpha );	// Alpha
	message_end();
}

stock set_user_clip(id, ammo)
{
	new weaponname[32], weaponid = -1, weapon = get_user_weapon(id, _, _);
	get_weaponname(weapon, weaponname, 31);
	while ((weaponid = find_ent_by_class(weaponid, weaponname)) != 0)
		if(entity_get_edict(weaponid, EV_ENT_owner) == id) 
		{
			set_pdata_int(weaponid, 51, ammo, 4);
			return weaponid;
		}
	return 0;
}

public plugin_natives(){
    register_library("CodMod_Items");
    register_native("cod_send_user_item", "_cod_send_user_item");
    register_native("cod_get_user_item", "_cod_get_user_item");
   
}

public _cod_get_user_item(plugin, params){
    if(params != 1)
        return 0;
    new id = get_param(1);
    if(!is_user_connected(id))
        return 0;
    return informacje_przedmiotu_gracza[id][0];
}

public _cod_send_user_item(plugin, params){
    if(params != 2)
        return 0;
    new id = get_param(1);
    if(!is_user_connected(id))
        return 0
    new id2 = get_param(2);
    if(!is_user_connected(id2))
        return 0
    if(informacje_przedmiotu_gracza[id][0] == 0)
        return 0;

    new temp[2];
    temp[0] = informacje_przedmiotu_gracza[id][0];
    temp[1] = informacje_przedmiotu_gracza[id][1];


    WyrzucPrzedmiot(id2);
    DajPrzedmiot(id2, temp[0]);
    informacje_przedmiotu_gracza[id2][1] = temp[1];

    WyrzucPrzedmiot(id);
   
    return 1;
}

public plugin_end(){
        new exp[3]={
                500,
                250,
                100
        }
        new fragi;
        new omijamy[3];
        for(new j=0;j<3;j++){
                for(new i=1;i<33;i++){
                        if(!is_user_connected(i) || i == omijamy[0] || i == omijamy[1]){
                                continue;
                        }
                        if(fragi < get_user_frags(i)){
                                fragi = get_user_frags(i);
                                omijamy[j] = i;
                        }
                }
                fragi = 0;
                doswiadczenie_gracza[omijamy[j]] += exp[j];
        }
}
//ColorChat(id, GREEN,"[Cosik]^x01 A nic");
#define MAXSLOTS 32
